#include <boost/asio.hpp>
#include <iostream>

class NetworkClient {
public:
    NetworkClient() : io_context_(), socket_(io_context_) {}

    void connect(const std::string& host, const std::string& port) {
        // Resolve the host and connect asynchronously
        boost::asio::ip::tcp::resolver resolver(io_context_);
        auto endpoints = resolver.resolve(host, port);
        boost::asio::async_connect(socket_, endpoints,
            [](const boost::system::error_code& ec, const boost::asio::ip::tcp::endpoint&) {
                if (!ec) {
                    std::cout << "Connected!" << std::endl;
                } else {
                    std::cout << "Connection failed: " << ec.message() << std::endl;
                }
            }
        );
        io_context_.run(); // Run the io_context for this instance
    }

private:
    boost::asio::io_context io_context_;
    boost::asio::ip::tcp::socket socket_;
};

int main() {
    NetworkClient client1;
    client1.connect("example.com", "80");

    NetworkClient client2;
    client2.connect("example.org", "80");

    return 0;
}
